
// Steady wave program - C++ version

#include <math.h>
#include <stdio.h>
#include <process.h>
#include <string.h>
#include <conio.h>
#define	ANSI
#include "Allocation.h"

#define pi			3.14159265358979324
#define iff(x,y)	if(strcmp(x,#y)==0)
#define HI			"\t%10.6f"
#define LO			"\t%7.4f"
#define Print		fprintf(out,

FILE 	*monitor, *in, *out;

char	title[100], dummy[100], Case[20];

int	i, j, m, n, num, number, wave, ns, nstep, Points, Ysteps, Current_criterion,
		Surface_points, Nprofiles;

int	Read_data(char);

double	**sol, *B, *Tanh, *Y, *coeff, *cosa, *rhs1, *rhs2, *sina, *z;
double	Bernoulli_check, Current, Eqns(double *), Eta, H, Height, Hoverd, L,
			MaxH, Pressure, Q, R, T, U, Ystep, c, ce, crit, criter, cs, height, dphidt,
         dudt, dvdt, kd, phi, psi, sum, u, ubar, ut, ux, uy, v, vt, vx, vy;
double	Surface(double);

void	init(void), Solve(void), Title_block(FILE*),	Output(void), Point(double, double);

void main()
{
int		iter, I;
char *Currentname;
double	X, y, eta;
double	Newton(int), dhe, dho, error, **CC, Highest, pulse, ke, pe, ub2, sxx, f, q, r, s;
void 		Powell(double *, double **, int, double, int *, double *,double (*)(double *));

in = fopen("Data.dat","r");
monitor = stdout;

for ( wave=1 ; ; wave++ )
	{
	if ( Read_data('y') == 0 ) break;
	num=2*n+10;
	dhe=Height/nstep;
	dho=MaxH/nstep;

	if ( wave == 1)
		{
		CC = dmatrix(1,num,1,num);
		for ( j=1; j <=num ; ++j)
			{
			for ( i=1; i <=num ; ++i)
				CC[j][i] = 0.;
			CC[j][j] = 1.;
			}
		Y = dvector(0,num);
		z = dvector(1,num);
		rhs1 = dvector(1,num);
		rhs2 = dvector(1,num);
		coeff = dvector(0, n);
		cosa = dvector(0,2*n);
		sina = dvector(0,2*n);
		sol = dmatrix(0,num,1,2);
      B = dvector(1, n);
		Tanh = dvector(1,n);
		}

//	Commence stepping through steps in wave height

	for ( ns = 1 ; ns <= nstep ; ns++ )
		{
		height=ns*dhe;
		Hoverd=ns*dho;
		if(ns==1)
			{
			fprintf(monitor,"\n\n");
			Title_block(monitor);
			}
		fprintf(monitor,"\n\nHeight step %2d of %2d", ns, nstep);
		iff(Case,Wavelength)
			{
			Highest = (0.0077829*L*L*L+0.0095721*L*L+0.141063*L)
				/(0.0093407*L*L*L+0.0317567*L*L+0.078834*L+1);
			fprintf(monitor,"\nH/d:%6.3f (Maximum value of %6.3f for L/d=%6.2f)\n",
		   	Hoverd,Highest,L);

			if(Hoverd >= Highest)
				{
				char *Message =
					"\nThe wave is higher than the maximum possible for that length/depth\n";
				fprintf(monitor,"%s",Message);
				exit(0);
				}
			}

//	Calculate initial linear solution

	if(ns <= 1)
		init();

//	Or, extrapolate for next wave height, if necessary

	else
		for ( i=1 ; i <= num ; i++ )
			z[i]=2.*sol[i][2]-sol[i][1];

	//Powell(z, CC, num, 1.e-3, &iter, &error, Eqns);

//	Commence iterative solution

	for (iter=1 ; iter <= number ; iter++ )
		{
		fprintf(monitor,"\nIteration%3d:", iter);

//	Calculate right sides of equations and differentiate numerically
//	to obtain Jacobian matrix, then solve matrix equation

		error = Newton(iter);

//	Convergence criterion satisfied?

		fprintf(stdout," Mean of corrections to free surface: %8.1e", error);
		if(ns == nstep)	criter = 1.e-10 ;
		else			criter = crit;
		if((error < criter * fabs(z[1]))  && iter > 1 ) break;
		if(iter == number)
			{
			fprintf(stdout,"\nNote that the program still had not converged to the degree specified\n");
			}

//	Operations for extrapolations if more than one height step used

		if(ns == 1)
			for ( i=1 ; i<=num ; i++ )
				sol[i][2] = z[i];
		else
			for ( i=1 ; i<=num ; i++ )
				{
				sol[i][1] = sol[i][2];
				sol[i][2] = z[i];
				}
			}

//	Fourier coefficients (for surface elevation by slow Fourier transform)

	for ( Y[0] = 0., j = 1 ; j <= n ; j++ )
		{
	   B[j]=z[j+n+10];
      sum = 0.5*(z[10]+z[n+10]*pow(-1.,(double)j));
		for ( m = 1 ; m <= n-1 ; m++ )
			sum += z[10+m]*cosa[(m*j)%(n+n)];
		Y[j] = 2. * sum / n;
		}
	} // End stepping through wave heights

// Print  results

kd = z[1];
L=2*pi/z[1];
H=z[2]/z[1];
T=z[3]/sqrt(z[1]);
c=z[4]/sqrt(z[1]);
ce=z[5]/sqrt(z[1]);
cs=z[6]/sqrt(z[1]);
ubar=z[7]/sqrt(z[1]);
Q=z[7]/sqrt(z[1])-z[8]/pow(z[1],1.5);
R=1+z[9]/z[1];

L = 2*pi/z[1];

// Highest wave - eqn (32) of Fenton (1990)

Highest = (0.0077829*L*L*L+0.0095721*L*L+0.141063*L)
		/(0.0093407*L*L*L+0.0317567*L*L+0.078834*L+1);
fprintf(monitor,"\nH/d:%6.3f (Maximum value of %6.3f for L/d=%6.2f)\n",
  	Hoverd,Highest,L);

out=fopen("Solution.res","w");

Print "\# %s", title);
Print "\n\# Height/Depth:%6.3f,", Hoverd);
iff(Case,Wavelength)
	Print " Length/Depth:%6.2f,", L);
iff(Case,Period)
	Print " Dimensionless Period:%6.2f", T);
if(Current_criterion==1) Currentname="Euler";
if(Current_criterion==2) Currentname="Stokes";

pulse=z[8]+z[1]*z[5];
ke=0.5*(z[4]*pulse+z[5]*(z[8]-z[7]*z[1]));
pe=0.5*(z[10]*z[10]+z[n+10]*z[n+10]);
for ( i=1 ; i<= n-1 ; i++ )
pe += z[10+i]*z[10+i];
pe=pe/(2.*n);
ub2=2.*z[9]-z[4]*z[4];
sxx=4.*ke-3.*pe+ub2*z[1]+2.*z[5]*(z[7]*z[1]-z[8]);
f=z[4]*(3.*ke-2.*pe)+0.5*ub2*(pulse+z[4]*z[1])+z[4]*z[5]*(z[7]*z[1]-z[8]);
q=z[7]*z[1]-z[8];
r=z[9]+z[1];
s=sxx-2.*z[4]*pulse+(z[4]*z[4]+0.5*z[1])*z[1];

Print " Current criterion: %s,  Magnitude:%5.2lf", Currentname,Current);
Print "\n\# (This has a height %2.0f\%% of the maximum value of H/d=%5.3f for this wavelength)\n", Hoverd/Highest*100, Highest);
Print "\n\# Solution by Fourier approximation: %2d terms in series", n);
Print "\n\n\# Integral quantities - notation from Fenton (1988)");
Print "\n\# (1) Quantity, (2) symbol, solution non-dimensionalised by (3) g \& wavenumber, and (4) g \& mean depth\n");
Print "\n\# Water depth                        (d)" LO LO, z[1], 1.);
Print "\n\# Wave length                   (lambda)" LO LO, 2*pi, L);
Print "\n\# Wave height                        (H)" LO LO, z[2], H);
Print "\n\# Wave period                      (tau)" LO LO, z[3], T);
Print "\n\# Wave speed                         (c)" LO LO, z[4], c);
Print "\n\# Eulerian current                 (u1_)" LO LO, z[5], ce);
Print "\n\# Stokes current                   (u2_)" LO LO, z[6], cs);
Print "\n\# Mean fluid speed in frame of wave (U_)" LO LO, z[7], ubar);
Print "\n\# Volume flux due to waves           (q)" LO LO, z[8], z[8]/pow(kd,1.5));
Print "\n\# Bernoulli constant                 (r)" LO LO, z[9], z[9]/kd);
Print "\n\# Volume flux                        (Q)" LO LO, q, q/pow(kd,1.5));
Print "\n\# Bernoulli constant                 (R)" LO LO, r, r/kd);
Print "\n\# Momentum flux                      (S)" LO LO, s, s/kd/kd );
Print "\n\# Impulse                            (I)" LO LO, pulse, pulse/pow(kd,1.5));
Print "\n\# Kinetic energy                     (T)" LO LO, ke, ke/kd/kd);
Print "\n\# Potential energy                   (V)" LO LO, pe, pe/kd/kd);
Print "\n\# Mean square of bed velocity     (ub2_)" LO LO, ub2, ub2/kd);
Print "\n\# Radiation stress                 (Sxx)" LO LO, sxx, sxx/kd/kd);
Print "\n\# Wave power                         (F)" LO LO, f, f/pow(kd,2.5));

Print "\n\n\# Dimensionless coefficients in Fourier series" );
Print "\n\# Potential/Streamfn\tSurface elevations" );
Print "\n\# j, B[j], \& E[j], j=1..N\n" );
for ( i=1 ; i <= n ; i++ )
Print "\n%2d\t%14.7e\t%14.7e", i, B[i], Y[i]);
fclose(out);

//	Surface - print out coordinates of points on surface for plotting plus check of pressure on surface

out = fopen("Surface.res","w");
Print "\# Surface of wave - trough-crest-trough,");
Print " note quadratic point spacing clustered around crest");
Print "\n\# Non-dimensionalised with respect to depth");
Print "\n\# X/d, eta/d, \& check of surface pressure\n");

for ( i=-Surface_points/2 ; i <= Surface_points/2; i++)
	{
	X = 2 * L * (i * fabs(i)/Surface_points/Surface_points);	//NB Quadratic point spacing, clustered near crest
   eta = Surface(X);
   Point(X,eta);
	Print "\n%8.4lf\t%7.4f\t%7.0e", X, eta, Pressure);
	}
fclose(out);

//	Print  out Velocity and acceleration profiles plus check of Bernoulli

out = fopen("Flowfield.res","w");
Print "\# %s", title);
Print "\n\# Velocity and acceleration profiles and Bernoulli checks\n");
Print "\n\# All quantities are dimensionless with respect to g and/or d\n");
Print "\n\#*******************************************************************************");
Print "\n\# y        u       v    dphi/dt   du/dt   dv/dt  du/dx   du/dy Bernoulli check  ");
Print "\n\# -     -------------   -------  ------   -----  ------------- ---------------  ");
Print "\n\# d        sqrt(gd)       gd        g       g       sqrt(g/d)        gd         ");
Print "\n\#*******************************************************************************");

for(I = 1; I <= Nprofiles ; ++I)
	{
	X = 0.5 * L *(I-1)/(Nprofiles-1);
	eta = Surface(X);
	Print "\n\n\# X/d = %8.4f, Phase = %6.1f\n", X, X/L*360);

	for(i=1 ; i <= Points; ++i)
		{
		y = (i-1)*eta/(Points-1);
		Point(X, y);
		Print "\n%7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f",
			y, u, v, dphidt, ut, vt, ux, uy, Bernoulli_check);
		}
	}
fclose(out);
	flushall();
	printf("\nTouch key to continue "); getch();
	} // End stepping through waves to consider
printf("\n\nFinished\n");
} // End main program

// Surface elevation

double Surface(double x)
{
int j;
static double kEta;

kEta = kd;
for ( j = 1 ; j < n ; j++ )
	kEta += Y[j] * cos(j*x*kd);
kEta += 0.5*Y[n] * cos(n*x*kd);
return (kEta/kd);
}

// Velocities, accelerations, and pressure at a point

void Point(double X, double y)
{
int j;
double Cosh, Sinh, Sin, Cos;
double coshdelta,sinhdelta;

u = v = ux = vx = phi = psi = 0.;

for ( j = 1 ; j <= n ; j++ )
	{
   Cos  = cos(j*X*kd);
	Sin  = sin(j*X*kd);
   coshdelta = cosh(j*kd*(y-1.));
   sinhdelta = sinh(j*kd*(y-1.));
   Cosh = coshdelta+sinhdelta*Tanh[j];
	Sinh = sinhdelta+coshdelta*Tanh[j];
   phi += B[j] * Cosh * Sin;
	u += j * B[j] * Cosh * Cos;
	v += j * B[j] * Sinh * Sin;
	ux += - j * j * B[j] * Cosh * Sin;
	vx += j * j * B[j] * Sinh * Cos;
	}

// All PHI, PSI, u, v, ux and vx are dimensionless w.r.t. g & k.
// Now convert to dimensionless w.r.t. d.

phi /= pow(kd,1.5);
u /= pow(kd,0.5);
v /= pow(kd,0.5);
ux *= pow(kd,0.5);
vx *= pow(kd,0.5);

u = ce + u;
phi = ce * X + phi;
dphidt = -c * u;

ut = -c * ux;
vt = -c * vx;
uy = vx;
vy = -ux;
dudt = ut + u*ux + v*uy;
dvdt = vt + u*vx + v*vy;
Pressure = R - y - 0.5 * ((u-c)*(u-c)+v*v);
Bernoulli_check = dphidt + Pressure + y + 0.5*(u*u+v*v)-(R-0.5*c*c);
return;
}

