function [ lambda,c_w,order,y,u,dudt,v,dudy,dudx,DuDt,x,eta ] = get_output(d,g,n_VP,n_PH  )

%KINEMATICS
tempdata1=importdata('Solution.res');
tempdata1=tempdata1.data;

lambda=tempdata1(2,2)*d;            %Wave Length [m]
c_w=tempdata1(5,2)*sqrt(g*d);       %Wave celerity [m/s]

 tempdata2=importdata('Solution.res',' ',33);
 tempdata2=tempdata2.data;

 order=length(tempdata2);


count=0;
for i=12:(3+n_VP):(n_PH)*(3+n_VP)                 %IMPORTING DATA
    count=count+1;
   
    tempdata=importdata('Flowfield.res', ' ', i);
  
    y(:,count)=tempdata.data(:,1).*d;          
    u(:,count)=tempdata.data(:,2).*sqrt(g*d);  
    dudt(:,count)=tempdata.data(:,5).*g;       
    v(:,count)=tempdata.data(:,3).*sqrt(g*d);
    dudy(:,count)=tempdata.data(:,8).*sqrt(g/d);
    dudx(:,count)=tempdata.data(:,7).*sqrt(g/d);
end

DuDt=dudt+u.*dudx+v.*dudy;            %Total acceleration of fluid particle


%SURFACE ELEVATION

tempdata=importdata('Surface.res', ' ', 4);
x=tempdata.data(:,1).*d;            %Points along surface [m]
eta=tempdata.data(:,2).*d;          %Wave elevation [m]






end

