clc
clear all

%Reading Environmental Data 
% [Year_n,~,~,~,Ws_all_n,Wdir_all_n,Hs_all_n,Tp_all_n,Mdir_all_n]=textread('Dogger_north.dat',...
% '%f %f %f %f %f %f %f %f %f','headerlines',3);
[Year_n,~,~,~,Ws_all_n,Wdir_all_n,Hs_all_n,Tp_all_n,Mdir_all_n]=textread('Dogger_Nora10_alt1.dat',...
'%f %f %f %f %f %f %f %f %f','headerlines',4);

%MORE DATA IN NORTH THAN IN SOUTH!

d_s=155837; %data south

Year_n=Year_n(1:d_s);
Ws_all_n=Ws_all_n(1:d_s);
Wdir_all_n=Wdir_all_n(1:d_s);

Hs_all_n=Hs_all_n(1:d_s);
Tp_all_n=Tp_all_n(1:d_s);
Mdir_all_n=Mdir_all_n(1:d_s);


dir_low=180; dir_high=180;        %OMNI  
%dir_low=360; dir_high=0;   %Only north

count=0;
Hs_n=zeros(0);
Tp_n=zeros(0);
Mdir_n=zeros(0);
Wdir_n=zeros(0);
Ws_n=zeros(0);
for i=1:length(Year_n)
%if Mdir(i)==0 || Mdir(i)==360
    if Mdir_all_n(i)<=dir_high && Mdir_all_n(i)>=0 || Mdir_all_n(i)<=360 && ...
                                                    Mdir_all_n(i)>=dir_low
%Creating matrices of Hs, Tp and Dir from within the direction interval
%(north)
        count=count+1;
        Hs_n(count,1)=Hs_all_n(i);
        Tp_n(count,1)=Tp_all_n(i);
        Mdir_n(count,1)=Mdir_all_n(i);
        Wdir_n(count,1)=Wdir_all_n(i);
        Ws_n(count,1)=Ws_all_n(i);
    end
end

% Hs_test=Hs_n(1:length(Hs_n));

figure(1)
plot(Hs_n,'b','DisplayName','H_{m0,north}')
hold on
t=4.79;        %Threshold level
plot([0 length(Hs_n)],[t t],'-.k','DisplayName','Threshold')
hold on


a=find(Hs_n>=t); %Position of Hs>2

b=diff(a);         %1 if within same Hs>2-range, 

c=find(b>1);    %Position of where a storm ends in Hs-vector

c_s=([1;c]);

last_i=1;
 for i=1:length(c)

    [k l]=max(Hs_n(a(last_i):a(c(i))));
    POT_mat_n(i)=k;
    POT_pos_n(i)=a(last_i)+l-1;
    last_i=c(i)+1;
     
 
 end
 
 [k l]=max(Hs_n(a(last_i):a(length(a))));
 
 if l~=length(Hs_n(a(last_i):a(length(a))))      %if there is a PEAK on last
                                                    %storm
    POT_mat_n(i+1)=k;
    POT_pos_n(i+1)=a(last_i)+l-1;
 end
 
 plot(POT_pos_n,POT_mat_n,'xr','MarkerSize',10,'LineWidth',2,'DisplayName','Peak_{north}')
%  xlim([0 6000])
%  title('Peak Over Threshold')
%  xlabel('Observation number')
%  ylabel('H_{m0}')
%  legend('show')
 
 hold on
 
n_storms_north=length(POT_mat_n) 
storms_per_year_north=length(POT_mat_n)/(Year_n(length(Year_n))-Year_n(1))



 %%

[Year_s,~,~,~,Ws_all_s,Wdir_all_s,Hs_all_s,Tp_all_s,Mdir_all_s]=textread('Dogger_south.dat',...
'%f %f %f %f %f %f %f %f %f','headerlines',3);

% dir_low=350; dir_high=10;   
%dir_low=360; dir_high=0;

count=0;
Hs_s=zeros(0);
Tp_s=zeros(0);
Mdir_s=zeros(0);
Wdir_s=zeros(0);
Ws_s=zeros(0);

for i=1:length(Year_s)
%if Mdir(i)==0 || Mdir(i)==360
    if Mdir_all_s(i)<=dir_high && Mdir_all_s(i)>=0 || Mdir_all_s(i)<=360 && ...
                                                    Mdir_all_s(i)>=dir_low
%Creating matrices of Hs, Tp and Dir from within the direction interval

        count=count+1;
        Hs_s(count,1)=Hs_all_s(i);
        Tp_s(count,1)=Tp_all_s(i);
        Mdir_s(count,1)=Mdir_all_s(i);
        Wdir_s(count,1)=Wdir_all_s(i);  %Wind dir
        Ws_s(count,1)=Ws_all_s(i);      %Wind speed
    end
end

Hs_test=Hs_s(1:length(Hs_s));

figure(1)
plot(Hs_s,'r','DisplayName','H_{m0,south}')
hold on
%t=6.5;        %Threshold level
% plot([0 length(Hs_test)],[t t],'r','DisplayName','Threshold')
% hold on

a=find(Hs_s>=t); %Position of Hs>2

b=diff(a);         %1 if within same Hs>2-range, 

c=find(b>1);    %Position of where a storm ends in Hs-vector

c_s=([1;c]);

last_i=1;
 for i=1:length(c)

    [k l]=max(Hs_s(a(last_i):a(c(i))));
    POT_mat_s(i)=k;
    POT_pos_s(i)=a(last_i)+l-1;
    last_i=c(i)+1;
     
 
 end
 
 [k l]=max(Hs_s(a(last_i):a(length(a))));
 
 if l~=length(Hs_s(a(last_i):a(length(a))))      %if there is a PEAK on last
                                                    %storm
    POT_mat_s(i+1)=k;
    POT_pos_s(i+1)=a(last_i)+l-1;
 end
 
 plot(POT_pos_s,POT_mat_s,'xg','MarkerSize',10,'LineWidth',2,'DisplayName','Peak_{south}')
 xlim([0 10000])
 title('Peak Over Threshold')
 xlabel('Observation number')
 ylabel('H_{m0}')
 legend1=legend('show');
set(legend1,'Location','NorthEastOutside');
 
hold off
 
n_storms_south=length(POT_mat_s) 
storms_per_year_south=length(POT_mat_s)/(Year_s(length(Year_s))-Year_s(1))





%%

pos_storm_n=94680;
pos_storm_s=pos_storm_n;

% storm_n=Hs_n(3087:3103);
storm_n=Hs_n((pos_storm_n-8):(pos_storm_n+8));
storm_s=Hs_s((pos_storm_s-8):(pos_storm_s+8));

storm_n_Ws=Ws_n((pos_storm_n-8):(pos_storm_n+8));
storm_s_Ws=Ws_s((pos_storm_s-8):(pos_storm_s+8));

storm_n_Wdir=Wdir_n((pos_storm_n-8):(pos_storm_n+8));
storm_s_Wdir=Wdir_s((pos_storm_s-8):(pos_storm_s+8));

storm_n_Mdir=Mdir_n((pos_storm_n-8):(pos_storm_n+8));
storm_s_Mdir=Mdir_s((pos_storm_s-8):(pos_storm_s+8));

figure(2)
plot(storm_n,'b','Marker','*','DisplayName','Hs_{north} [m]')
hold on
plot(storm_n_Ws./2,'r','Marker','*','DisplayName','Ws_{north}/2 [m/s]')
hold on
plot(storm_n_Wdir./100,'g','Marker','*','DisplayName','Wdir_{north}/100 [deg]')
hold on
plot(storm_n_Mdir./100,'y','Marker','*','DisplayName','Mdir_{north}/100 [deg]')
hold off
legend('show')
title('Storm data north')
grid on

figure(3)
plot(storm_s,'b','Marker','*','DisplayName','Hs_{south} [m]')
hold on
plot(storm_s_Ws./2,'r','Marker','*','DisplayName','Ws_{south}/2 [m/s]')
hold on
plot(storm_s_Wdir./100,'g','Marker','*','DisplayName','Wdir_{south}/100 [deg]')
hold on
plot(storm_s_Mdir./100,'y','Marker','*','DisplayName','Mdir_{south}/100 [deg]')
hold off
legend('show')
title('Storm data south')
grid on

%[c_ww,lags] = xcorr(Hs_n,Hs_s'coeff');



% Y=xcorr(r,x);
% R=Y(1:N);
% 	


figure(4),plot(storm_n,'Displayname','H_{m0},{north} [m]');
hold on
plot(storm_s,'r','Displayname','H_{m0},{south} [m]');
hold off
legend('show')
xlabel('H_{m0} [m]')
ylabel('H_{m0} [m]')
title('Significant wave height of a storm in north and south')

[correlation,lags] = xcorr(storm_n,storm_s);
delay = lags(find(correlation==max(correlation)));

% figure(6)
% plot(storm_n)
% hold on
% plot([(delay+1):(length(storm_s)+delay)],storm_s,'r') %PLOT ALIGNED
% hold off
% grid on



%%
%FINDING TIME DELAY OF THE 20 LARGEST STORMS

[a b]=sort(POT_mat_n,'descend');
pos_largest=POT_pos_n(b(1:20));             %Position of 20 largest stormPEAKS NORTH

[aa bb]=sort(POT_mat_s,'descend');
pos_largest_s=POT_pos_s(bb(1:20)); 
 

for i=1:20
   storm_n=Hs_n((pos_largest(i)-8):(pos_largest(i)+8));
   storm_s=Hs_s((pos_largest(i)-8):(pos_largest(i)+8));
   
   [correlation,lags] = xcorr(storm_n,storm_s);     %Crosscorrelation between the largest storms in north
   delay(i)=lags(find(correlation==max(correlation)));%and the corresponding storm in south
   
   wdir_largest(i)=Wdir_n(pos_largest(i));      %Wave direction of 20 largest storm peaks north
   wdir_largest_s(i)=Wdir_s(pos_largest_s(i));  %Wave direction of 20 largest storm peaks south
   
   [ii_n iii_n]=max(storm_n);
   max_n(i)=ii_n;
   [ii_s iii_s]=max(storm_s);
   max_s(i)=ii_s;
   
   delay_max(i)=iii_s-iii_n;
   
   
end

for i=1:length(wdir_largest)        %Increasing direction range above 360
if wdir_largest(i)<=30
wdir_largest(i)=wdir_largest(i)+360;
wdir_largest(i)=wdir_largest(i)+360;

elseif wdir_largest_s(i)<=30
wdir_largest_s(i)=wdir_largest_s(i)+360;    
    
end

end

figure(5)
plot(wdir_largest,'.','displayname','Direction')
str=['Wave direction of ',num2str(length(wdir_largest)),' largest storms at nothern point'];
title(str)
ylabel('Direction [deg]')
xlabel('Storm number')
hold on
% plot([0 length(wdir_largest)],[mean(wdir_largest) mean(wdir_largest)],'--k')
% plot([0 length(wdir_largest)],[mean(wdir_largest)+std(wdir_largest) mean(wdir_largest)+std(wdir_largest)],'--r')
% plot([0 length(wdir_largest)],[mean(wdir_largest)-std(wdir_largest) mean(wdir_largest)-std(wdir_largest)],'--r')
plot([0 length(wdir_largest)],[330 330],':k','displayname','330 [deg]')
plot([0 length(wdir_largest)],[375 375],':k','displayname','375 (15) [deg]')
str=['Median ',num2str(median(wdir_largest)),' [deg]']
plot([0 length(wdir_largest)],[median(wdir_largest) median(wdir_largest)],'--r','displayname',str)
hold off
legend('show','Orientation','horizontal','Location','NorthOutside');

figure(6)
plot(wdir_largest_s,'.','displayname','Direction')
str=['Wave direction of ',num2str(length(wdir_largest_s)),' largest storms at southern point'];
title(str)
ylabel('Direction [deg]')
xlabel('Storm number')
hold on
plot([0 length(wdir_largest_s)],[330 330],':k','displayname','330 [deg]')
plot([0 length(wdir_largest_s)],[375 375],':k','displayname','375 (15) [deg]')
str=['Median ',num2str(median(wdir_largest_s)),' [deg]']
plot([0 length(wdir_largest_s)],[median(wdir_largest_s) median(wdir_largest_s)],'--r','displayname',str)
hold off
legend('show','Orientation','horizontal','Location','NorthOutside');

figure(7)
plot(Hs_n(pos_largest),'Marker','*')
hold on
plot(Hs_s(pos_largest),'r','Marker','*')
hold on
plot(max_s,'g.')
ylabel('Hs')
xlabel('Largest storms')
hold off


figure(8)
plot(delay)
title('Time delay from north to south')
xlabel('Storm number')
ylabel('x3 [Hours]')

