clc
clear all
format long

%Reading Environmental Data 
[Year_n,mm,dd,hh,Ws_all_n,Wdir_all_n,Hs_all_n,Tp_all_n,Mdir_all_n]=textread('Dogger_Nora10_alt1.dat',...
'%f %f %f %f %f %f %f %f %f','headerlines',4);



dir_low=330; dir_high=15;        %OMNI  
%dir_low=360; dir_high=0;   %Only north

count=0;
Hs_n=zeros(0);
Tp_n=zeros(0);
Mdir_n=zeros(0);
Wdir_n=zeros(0);
Ws_n=zeros(0);
for i=1:length(Year_n)
%if Mdir(i)==0 || Mdir(i)==360
    if Mdir_all_n(i)<=dir_high && Mdir_all_n(i)>=0 || Mdir_all_n(i)<=360 && ...
                                                    Mdir_all_n(i)>=dir_low
%Creating matrices of Hs, Tp and Dir from within the direction interval
%(north)
        count=count+1;
        Hs_n(count,1)=Hs_all_n(i);
        Tp_n(count,1)=Tp_all_n(i);
        Mdir_n(count,1)=Mdir_all_n(i);
        Wdir_n(count,1)=Wdir_all_n(i);
        Ws_n(count,1)=Ws_all_n(i);
    end
end

% Hs_test=Hs_n(1:length(Hs_n));

figure(1)
plot(Hs_n,'b','DisplayName','H_{m0}')
hold on
t=4.79;        %Threshold level
plot([0 length(Hs_n)],[t t],'-.k','DisplayName','Threshold')
hold on
xlabel('Observation number')
ylabel('H_{m0}')

a=find(Hs_n>=t); %Position of Hs>2

unike=diff(a);         %1 if within same Hs>2-range, 

c=find(unike>1);    %Position of where a storm ends in Hs-vector

c_s=([1;c]);

last_i=1;
 for i=1:length(c)

    [k l]=max(Hs_n(a(last_i):a(c(i))));
    POT_mat_n(i)=k;
    POT_pos_n(i)=a(last_i)+l-1;
    last_i=c(i)+1;
     
 
 end
 
 [k l]=max(Hs_n(a(last_i):a(length(a))));
 
 if l~=length(Hs_n(a(last_i):a(length(a))))      %if there is a PEAK on last
                                                    %storm
    POT_mat_n(i+1)=k;
    POT_pos_n(i+1)=a(last_i)+l-1;
 end
 
 plot(POT_pos_n,POT_mat_n,'xr','MarkerSize',10,'LineWidth',2,'DisplayName','Peak')
%  xlim([0 6000])
%  title('Peak Over Threshold')
%  xlabel('Observation number')
%  ylabel('H_{m0}')
%  legend('show')
 
 hold on
 
n_storms_north=length(POT_mat_n) 
storms_per_year_north=length(POT_mat_n)/(Year_n(length(Year_n))-Year_n(1))



Y=POT_mat_n-t;

%Y=[0.438 2.413 3.073 3.079 3.137 3.198 3.918 4.287 4.508 4.981 5.115 5.592 5.848 5.958 6.013];

unike=unique(Y);
n=length(Y);
P=zeros(0)
for i=1:length(unike)
    
    c=length(find(Y<=unike(i)));
    P(i)=c/(n+1);
    obs(i)=c;
end


%figure(3)
%ecdf(Y)

dummy_etta=0:0.0001:3;
CV_1=real(gamma(1+(2./dummy_etta)));
CV_2=real(gamma(1+(1./dummy_etta)));
CV_3=real(gamma(1+(1./dummy_etta)));
CV=real((sqrt(CV_1-CV_2.^2))./CV_3);

CV_estimate=std(Y)/mean(Y);

[a b]=min(abs(CV-CV_estimate));

etta_est=dummy_etta(b);

sigma_est=mean(Y)/gamma(1+(1/etta_est));


m=50;              %Years

n_years=(Year_n(length(Year_n))-Year_n(1))+...    %Duration of measurements
        (mm(length(mm))-mm(1))/12+(dd(length(dd))-dd(1))/365+...
        (hh(length(hh))-hh(1))/(365*24);

N_m=length(Y)*m/n_years;    %Estimated number of sea states during m years
                            %within the direction-range!
                            
hs_50_wbl=wblinv(1-1/N_m,sigma_est,etta_est)+t

figure(2)
plot(log(unike),log(-log(1-P)),'.','displayname','Data')
hold on
plot(log(unike),log(-log(1-wblcdf(unike,sigma_est,etta_est))),'r','displayname','Distribution')
plot(log(unike),log(-log(1-expcdf(unike,mean(Y)))),'r:','displayname','Distribution_{exp}')

hold off
legend('Location','NW')
xlabel('$\ln ({H_{m0}})$','Interpreter','LaTex')
ylabel('$\ln \left[ { - \ln (1 - {F_{{H_{m0}}}}({H_{m0}}))} \right]$','Interpreter','LaTex')
title('Weibull fit from Moment Estimators')

mse_weibull=sum(((wblcdf(unike,sigma_est,etta_est)-(P)).^2))

figure(3)
plot(unike,-log(1-P),'.','displayname','Data')
hold on
plot(unike,-log(1-expcdf(unike,mean(Y))),'r','displayname','Distribution_{exp}')

plot(unike,(-log(1-wblcdf(unike,sigma_est,etta_est))),'r--','displayname','Distribution_{wbl}')


hold off
legend('Location','NW')
xlabel('Y')
ylabel('-ln[1-F_Y(Y)]')
title('Distribution fit from moment estimator - Exponential plot')
hs_50_wexp=expinv(1-1/N_m,mean(Y))+t

mse_exp=sum(((expcdf(unike,mean(Y))-(P)).^2))


%%MONTE CARLO

F_y=rand(length(Y),100);
MC_matrix=exp((log(-log(1-F_y))+etta_est.*log(sigma_est))./etta_est);

MC_P=zeros(0);

for j=1:size(MC_matrix,2)
%MC_unike=unique(MC_matrix(:,j));
MC_sort=sort(MC_matrix);
n=length(MC_matrix(:,j));

for i=1:length(MC_sort)
    
    c=length(find(MC_matrix(:,j)<=MC_sort(i,j)));
    MC_P(i,j)=c/(n+1);
    
end
end
figure(4)
plot(MC_sort,-log(1-MC_P),'b.','HandleVisibility','off')
hold on
plot([0],[0],'b.','displayname','Data from 100 Monte Carlo Simulations')
plot(unike,-log(1-P),'ro','displayname','POT data')
plot(unike,-log(1-expcdf(unike,mean(Y))),'r','displayname','Distribution_{exp}','LineWidth',1)
plot(unike,(-log(1-wblcdf(unike,sigma_est,etta_est))),'r--','displayname','Distribution_{wbl}','LineWidth',1)
legend('Location','SE')
xlabel('Y')
ylabel('-ln[1-F_Y(Y)]')
title('Comparison with Monte Carlo Simulation')






%%FINDING WINDSPEED FOR SWAN RUN

[a b]=sort(POT_mat_n,'descend');
pos_largest=POT_pos_n(b(1:5));



figure(5)
hold on
plot(Ws_n((pos_largest(1)-2):(pos_largest(1)+1)))
plot(3, Ws_n(pos_largest(1)),'*r')

plot(Ws_n((pos_largest(2)-2):(pos_largest(2)+1)),'g')
plot(3, Ws_n(pos_largest(2)),'*r')

plot(Ws_n((pos_largest(3)-2):(pos_largest(3)+1)),'y')
plot(3, Ws_n(pos_largest(3)),'*r')

hold off





mean1=mean(Ws_n((pos_largest(1)-2):(pos_largest(1)+1)));
mean2=mean(Ws_n((pos_largest(2)-2):(pos_largest(2)+1)));
mean3=mean(Ws_n((pos_largest(3)-2):(pos_largest(3)+1)));

meandir1=0;
meandir2=0;
meandir3=0;
mean=mean([mean1 mean2 mean3])

