clear all

clc

[long,lat,d]=textread('Dogger_500m_grid.txt',...
'%f %f %f','headerlines',1);

d=d;

tempVec=[];
for i=0:416:(length(d)-416)
    tempVec=[tempVec d(i+1:i+416)];
    
    
end




x=374560:500:374560+186000;
y=5992690+207500:-500:5992690;
y2=5992690:500:5992690+207500;

[X Y]=meshgrid(x,y);




figure(1)
surf(X,Y,-tempVec)
%axis off
%l = light('Position',[-50 -15 29]);
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside
 title('Bathymetry')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')
pbaspect([186000 207500 186000])


x1=435431.08;       %Alt1
y1=6184300.53;



x2=437766.47;
y2=6081869;

distance=sqrt((x1-x2)^2+(y1-y2)^2)

dist1=((x1-long).^2+(y1-lat).^2).^(0.5);
dist2=((x2-long).^2+(y2-lat).^2).^(0.5);

[min_dist1 min_pos1]=min(dist1)
[min_dist2 min_pos2]=min(dist2)


hold on

 plot3(long(min_pos1),lat(min_pos1),d(min_pos1)+7,'ks','markerfacecolor',[0 0 0])
 text(long(min_pos1)+5000,lat(min_pos1)-5000,['Depth: ', num2str(d(min_pos1)),' m'])
 hold on
 plot3(long(min_pos2),lat(min_pos2),d(min_pos2)+1,'ks','markerfacecolor',[0 0 0])
  text(long(min_pos2)+5000,lat(min_pos2)-5000,['Depth: ', num2str(d(min_pos2)),' m'])


line([374560 374560+186000],[lat(min_pos1) lat(min_pos1)],[0 0],'color',[0 0 0])
  
line([374560 374560+186000],[6050190 6050190],[0 0],'color',[0 0 0]) 

rectangle('Position',[long(min_pos2)-15000,lat(min_pos2)-15000,30000,30000])
  
  view(0,90)
  
  hold off

  %%
  cut=find(Y(:,1)==lat(min_pos1));
  
  
  tempVec2=tempVec;
  tempVec2(1:cut,:)=[];
  
  

  X2=X;
  Y2=Y;
  
  X2(1:cut-1,:)=[];
  Y2(1:cut-1,:)=[];
  
  cut2=find(Y2(:,1)==6050190);
  
  tempVec2(cut2+1:length(tempVec2),:)=[];
  
 X2(cut2+1:length(X2),:)=[];
 Y2(cut2+1:length(Y2),:)=[];
  
 
 x22=374560:500:374560+186000;
 y22=6184190:-500:6050190;
 
 [X22 Y22]=meshgrid(x22,y22);
 
  figure(2)
  surf(X2,Y2,-tempVec2)
%axis off
%l = light('Position',[-50 -15 29]);
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside
 title('Bathymetry')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')
pbaspect([186000 207500 186000])
view(0,90)
xlim([3.5*10^5 6*10^5])
 ylim([5.95*10^6 6.25*10^6])
  
hold on

 plot3(long(min_pos1),lat(min_pos1),d(min_pos1)+7,'ks','markerfacecolor',[0 0 0])
 text(long(min_pos1)+5000,lat(min_pos1)-5000,['Depth: ', num2str(d(min_pos1)),' m'])
 hold on
 plot3(long(min_pos2),lat(min_pos2),d(min_pos2)+1,'ks','markerfacecolor',[0 0 0])
  text(long(min_pos2)+5000,lat(min_pos2)-5000,['Depth: ', num2str(d(min_pos2)),' m'])


line([374560 374560+186000],[lat(min_pos1) lat(min_pos1)],[0 0],'color',[0 0 0])
  
line([374560 374560+186000],[6050190 6050190],[0 0],'color',[0 0 0]) 

rectangle('Position',[long(min_pos2)-15000,lat(min_pos2)-15000,30000,30000])
  
  
  hold off
  
 % 
fid=fopen('bottom_cut.txt','w');

for i=1:size(tempVec2,1)

    str=num2str(tempVec2(i,:));
    
fprintf(fid,'%s\n',str);

end

fclose(fid)

Hs_coarse=load('SWAN/Hs_distr/hs_distr_coarse.mat');
Hs_fine=load('SWAN/Hs_distr/hs_distr_fine.mat');


Hs_coarse=double(Hs_coarse.Hsig);
Hs_fine=double(Hs_fine.Hsig);

figure(3)
surf(X,Y,Hs_coarse)
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside
 title('Hs')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')
%pbaspect([186000 207500 186000])
 view(0,90)
hold on
 rectangle('Position',[long(min_pos2)-15000,lat(min_pos2)-15000,30000,30000])
 line([374560 374560+186000],[lat(min_pos1) lat(min_pos1)],[20 20],'color',[0 0 0])
line([374560 374560+186000],[6050190 6050190],[0 0],'color',[0 0 0]) 
hold off


 
 xx=422560:30000/1500:422560+30000;
 yy=6066690+30000:-30000/1500:6066690;
 
 [XX YY]=meshgrid(xx,yy);
 
 
 figure(4)
surf(XX,YY,Hs_fine)
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside
 title('Hs')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')
%pbaspect([186000 207500 186000])
 view(0,90)
 xlim([3.5*10^5 6*10^5])
 ylim([5.95*10^6 6.25*10^6])
 set(gca, 'CLim', [2.1769, 11.3249]); 
hold on
 line([374560 374560+186000],[lat(min_pos1) lat(min_pos1)],[20 20],'color',[0 0 0])
line([374560 374560+186000],[6050190 6050190],[0 0],'color',[0 0 0]) 
rectangle('Position',[long(min_pos2)-15000,lat(min_pos2)-15000,30000,30000])
 hold off
 
  figure(5)
surf(XX,YY,Hs_fine)
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside
 title('Hs')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')
%pbaspect([186000 207500 186000])
 view(0,90)
%  xlim([3.5*10^5 6*10^5])
%  ylim([5.95*10^6 6.25*10^6])
%  set(gca, 'CLim', [2.1769, 11.3249]); 













Hs_long=load('SWAN/Hs_distr/hs_distr_long2.mat');
botlev_long=load('SWAN/Hs_distr/botlev_long2.mat');

Hs_long=double(Hs_long.Hsig);
botlev_long=double(botlev_long.Botlev);


xxx=374560:279000/558:(374560+279000);
yyy=(5992690+207500):-207500/415:5992690;

[XXX YYY]=meshgrid(xxx,yyy);

figure(6)
surf(XXX,YYY,-botlev_long)
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside
 title('Hs')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')
%pbaspect([186000 207500 186000])
 view(0,90)

figure(7)
surf(XXX,YYY,Hs_long)
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside
 title('Hs')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')
%pbaspect([186000 207500 186000])
 view(0,90)
 set(gca, 'CLim', [2.1769, 11.3249]); 
 xlim([(3.5*10^5+93000/2) (6*10^5+93000/2)])

hold on
 line([374560+93000/2 374560+186000+93000/2],[lat(min_pos1) lat(min_pos1)],[20 20],'color',[0 0 0])
line([374560+93000/2 374560+186000+93000/2],[6.05*10^6 6.05*10^6],[20 20],'color',[0 0 0]) 

 hold off



 a= find(x==long(min_pos2));

 b=find(y==lat(min_pos2));
 
 HS_point_coarse=Hs_coarse(b,a)
 
aa= find(xx==long(min_pos2));
bb=find(yy==lat(min_pos2));

HS_point_fine=Hs_fine(bb,aa)

aaa= find(xxx==long(min_pos2)+93000/2);
bbb=find(yyy==lat(min_pos2));

HS_point_long=Hs_long(bbb,aaa)


figure(3)
hold on
plot3(X(b,a),Y(b,a),30,'ks','markerfacecolor',[0 0 0])
hold off

figure(4)
hold on
plot3(XX(bb,aa),YY(bb,aa),30,'ks','markerfacecolor',[0 0 0])
hold off
 
figure(5)
hold on
plot3(XX(bb,aa),YY(bb,aa),30,'ks','markerfacecolor',[0 0 0])
hold off
 

figure(7)
hold on
plot3(XXX(bbb,aaa),YYY(bbb,aaa),30,'ks','markerfacecolor',[0 0 0])
hold off


