%http://home.hiwaay.net/~taylorc/toolbox/geography/geoutm.html

clear all
clc

[long,lat,d]=textread('Dogger_500m_grid.txt',...
'%f %f %f','headerlines',1);

d=-d;
x = linspace(min(long),max(long));  %100 punkter i x-retn(interpolert!)
y = linspace(min(lat),max(lat));


[Xinterp, Yinterp] = meshgrid(x,y);

Zinterp = griddata(long,lat,d,Xinterp,Yinterp);

%clf
%hold on
%contourf(Xinterp,Yinterp,Zinterp)

figure(1)

surf(Xinterp,Yinterp,Zinterp)
%axis off
l = light('Position',[-50 -15 29]);
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside

%%

%Closest points to HINDCAST-data
% x1=438756.62;     %Alt2
% y1=6153086.5;

x1=435431.08;       %Alt1
y1=6184300.53;



x2=437766.47;
y2=6081869;

distance=sqrt((x1-x2)^2+(y1-y2)^2)

dist1=((x1-long).^2+(y1-lat).^2).^(0.5);
dist2=((x2-long).^2+(y2-lat).^2).^(0.5);

[min_dist1 min_pos1]=min(dist1)
[min_dist2 min_pos2]=min(dist2)





figure(2);
 plot3k({long lat d})
 hold on
 plot3(long(min_pos1),lat(min_pos1),d(min_pos1)+7,'ks','markerfacecolor',[0 0 0])
 text(long(min_pos1)+5000,lat(min_pos1)-5000,['Depth: ', num2str(d(min_pos1)),' m'])
 hold on
 plot3(long(min_pos2),lat(min_pos2),d(min_pos2)+1,'ks','markerfacecolor',[0 0 0])
  text(long(min_pos2)+5000,lat(min_pos2)-5000,['Depth: ', num2str(d(min_pos2)),' m'])

 xlim([min(long) max(long)])
 ylim([min(lat) max(lat)])
 xlabel('[m]')
 ylabel('[m]')
 title('Dogger Bank Topography')
 view(0,90)
 
 line([523881.179 502040.715 467043.014 434004.722 411989.454 412294.919 ...
    392151.415 402499.111 523881.179],[6183076.076 6089767.141 6090568.577 ...
    6057358.865 6066904.467 6079765.682 6081206.010 6131390.223 6183076.076],'color','k')
 
 hold off
 
 
 
 
% long1=long(1:10:end);
% lat1=lat(1:10:end);
% 
% [X Y]=meshgrid(long1,lat1);
%%
figure(3)
pos=find(long==long(min_pos1));   
pos2=find(long==long(min_pos2));

lat_pos=lat(pos);
lat_pos2=lat(pos2);

d_a=d(pos);
plot(lat_pos,d_a);            %Profil
hold on
p=find(lat_pos==lat(min_pos1));
plot(lat(p),d(min_pos1),'rs','markerfacecolor',[0 0 0])
text(lat(p)+5000,d(min_pos1),['Depth: ', num2str(d(min_pos1)),' m'])

q=find(lat_pos==lat(min_pos2));
plot(lat(q),d(min_pos2),'rs','markerfacecolor',[0 0 0])
text(lat(q)+5000,d(min_pos2),['Depth: ', num2str(d(min_pos2)),' m'])


xlabel('[m]')
ylabel('[m]')

title('Bottom profile between northen and souther point')
hold off


% hold on
% 
% plot(lat_a_1(1:5:end),d_a(1:5:end),'r'); 
% 
%  hold off
%%


tempVec=[];
for i=0:416:(length(d)-416)
    tempVec=[tempVec d(i+1:i+416)];
    
    
end


