clc

format short


clear all



for runs=1:4
%clearvars -except WP_vect x_axis Hs_evolve spec_start spec_end Hs_start_full Hs_end_full Hs_start_model Hs_end_model runs SPEC_1 SPEC_2 SPEC_3 SPEC_4 SPEC_5 SPEC_6 F1 F2 F3 F4 F5 F6
    
str3=['Runs\',num2str(runs),'\out_wp07_end.tab'];

[~,y,d,Hs_evol,~,~,~,~]=textread(str3,...
'%f %f %f %f %f %f %f %f','headerlines',7);

% Hs_evolve(:,runs)=Hs_evol;

        if runs==1
            Hs_evolve5000=Hs_evol;
            y5000=y;
            elseif runs==2
            Hs_evolve7500=Hs_evol;
            y75000=y;
            elseif runs==3
            Hs_evolve20000=Hs_evol;
            y20000=y;
            elseif runs==4
            Hs_evolve_bound=Hs_evol;
            y_bound=y;


        end

end

figure(1)
plot(y5000+7500,Hs_evolve5000,y75000+6250,Hs_evolve7500,y20000,Hs_evolve20000,y_bound+7500,Hs_evolve_bound)
test2=legend('Width = 5000 m','Width = 7500 m','Width = 20000 m','Spectrum on three boundaries')
set(test2,'Location','best')
xlabel('Position along y-axis [m]')
ylabel('H_{m0} [m]')
title('H_{m0} at d = 15 m- Effect of distance to water boundaries')

test1=load('hs_distr.mat');
test2=load('hs_distr2.mat');

Hsig1=test1.Hsig;

Hsig2=test2.Hsig;

Hsig1(:,55:70)=[];
Hsig2(:,55:70)=[];

Hsig1=double(Hsig1);
Hsig2=double(Hsig2);

x=0:1377.187/69:1377.187;
y=0:5000/251:5000;

x=x(1:length(x)-16);

[X Y]=meshgrid(x,y);

figure(2)
surf(X,Y,Hsig1)
%axis off
l = light('Position',[-50 -15 29]);
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside
 title('Significant wave height over the computational domain - Short crested sea state')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')
pbaspect([1 2 1])
view(126,12)

figure(3)
surf(X,Y,Hsig2)
%axis off
l = light('Position',[-50 -15 29]);
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside
 title('Significant wave height over the computational domain - Long crested sea state')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')
pbaspect([1 2 1])
view(126,12)

figure(4)
hold on
grid on
surf(X,Y,Hsig2)
alpha(0.3)
surf(X,Y,Hsig1)
l = light('Position',[-50 -15 29]);
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside
 title('Significant wave height over the computational domain - Long crested sea state')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')
pbaspect([1 2 1])
hold off
view(126,12)









%%

hs5000=load('Hs_distr/hs_distr_5000.mat');
hs7500=load('Hs_distr/hs_distr_7500.mat');
hs20000=load('Hs_distr/hs_distr_20000.mat');
hs_boundspec=load('Hs_distr/hs_distr_boundspec.mat');


hs5000=double(hs5000.Hsig);
hs7500=double(hs7500.Hsig);
hs20000=double(hs20000.Hsig);
hs_boundspec=double(hs_boundspec.Hsig);

x=0:1377.187/69:1377.187;

y_5000=0:5000/251:5000;
y_7500=0:7500/377:7500;
y_20000=0:20000/1004:20000;

[X5000 Y5000]=meshgrid(x,y_5000);
[X7500 Y7500]=meshgrid(x,y_7500);
[X20000 Y20000]=meshgrid(x,y_20000);


figure(5)
surf(X5000,Y5000,hs5000)
grid on
l = light('Position',[-50 -15 29]);
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside
 title('Significant wave height - Width = 5000 m')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')
pbaspect([1 2 1])
hold off
view(126,12)

figure(5)
surf(X7500,Y7500,hs7500)
grid on
l = light('Position',[-50 -15 29]);
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside
 title('Significant wave height - Width = 7500 m')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')
pbaspect([1 2 1])
hold off
view(126,12)


figure(6)
surf(X20000,Y20000,hs20000)
grid on
l = light('Position',[-50 -15 29]);
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside
 title('Significant wave height - Width = 20000 m')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')
pbaspect([1 2 1])
hold off
view(126,12)

figure(7)
surf(X5000,Y5000,hs_boundspec)
grid on
l = light('Position',[-50 -15 29]);
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside
 title('Significant wave height - Input spectrum on three boundaries')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')
pbaspect([1 2 1])
hold off
view(126,12)


bot_test=load('Hs_distr/botlev_extend.mat');
bot_test=double(bot_test.Botlev);

xx=374560:(200000)/400:(374560+200000);
yy=5992690:(222500)/445:(5992690+222500);

[XX YY]=meshgrid(xx,yy);


figure(8)
surf(XX,YY,bot_test)
grid on
l = light('Position',[-50 -15 29]);
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside
 title('Significant wave height - Input spectrum on three boundaries')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')
pbaspect([1 2 1])
hold off
view(126,12)