function [fit_my, gof] = my_fit(avg_Hs, my)
%CREATEFIT1(AVG_HS,MY)
%  Create a fit.
%
%  Data for 'untitled fit 1' fit:
%      X Input : avg_Hs
%      Y Output: my
%  Output:
%      fitresult : a fit object representing the fit.
%      gof : structure with goodness-of fit info.
%
%  See also FIT, CFIT, SFIT.

%  Auto-generated by MATLAB on 31-Jan-2012 17:32:50


%% Fit: 'untitled fit 1'.
[xData, yData] = prepareCurveData( avg_Hs, my );

% Set up fittype and options.
ft = fittype( 'a_0+a_1*x^a_2', 'independent', 'x', 'dependent', 'y' );
opts = fitoptions( ft );
opts.Display = 'Off';
opts.Lower = [-Inf -Inf -Inf];
opts.StartPoint = [0.56119979270966 0.88186650045181 0.669175304534394];
opts.Upper = [Inf Inf Inf];

% Fit model to data.
[fit_my, gof] = fit( xData, yData, ft, opts );

% Plot fit with data.
%figure( 'Name', 'untitled fit 1' );
h = plot( fit_my, xData, yData );
legend( h, '\mu vs. H_{m0}', 'Fitted line', 'Location', 'NorthWest' );
% Label axes
xlabel( 'H_{m0}');
ylabel( '\mu=E[ln(T_p)]' );
grid on


