clear all
clc

%%
%Reading Environmental Data 
[Year,mm,dd,hh,~,~,Hs_all_n,Tp_all_n,Mdir_all_n]=textread('Dogger_Nora10_alt1.dat',...
'%f %f %f %f %f %f %f %f %f','headerlines',4);

%MORE DATA IN NORTH THAN IN SOUTH!

d_s=155837; %data south

Year=Year(1:d_s);
mm=mm(1:d_s);
dd=dd(1:d_s);
hh=hh(1:d_s);
Hs_all_n=Hs_all_n(1:d_s);
Tp_all_n=Tp_all_n(1:d_s);
Mdir_all_n=Mdir_all_n(1:d_s);

%%
%Storing data from specific direction in matrices

    %---------
%INPUT
dir_low=180; dir_high=180;           %Lower and higher limit of direction


count=0;
Hs_n=zeros(0);
Tp_n=zeros(0);
Mdir_n=zeros(0);

for i=1:length(Year)
%if Mdir(i)==0 || Mdir(i)==360
    if Mdir_all_n(i)<=dir_high && Mdir_all_n(i)>=0 || Mdir_all_n(i)<=360 && ...
                                                    Mdir_all_n(i)>=dir_low
%Creating matrices of Hs, Tp and Dir from within the direction interval
%(north)
        count=count+1;
        Hs_n(count,1)=Hs_all_n(i);
        Tp_n(count,1)=Tp_all_n(i);
        Mdir_n(count,1)=Mdir_all_n(i);
    end
end
%%
%CREATING SCATTER DIAGRAM
max_Hs_n=ceil(max(Hs_n)*2)/2;   %If Hs interval is 0.5 - (number of columns-1)
%max_Hs=ceil(max(Hs)*4)/4;  %If Hs interval is 0.25

ScatterDiag_n=zeros(max_Hs_n*2+1,23); %23: Legger inn enda en kolonne senere (linje 64)

n=length(Mdir_n);

for j=1:n    
    Hs_dummy=Hs_n(j);  Tp_dummy=Tp_n(j);    
    
    [temp_data]=place_HsTp(Hs_dummy,Tp_dummy,max_Hs_n);  
                                                %Placing the number "1"
                                                %in the correct cell in SD
    ScatterDiag_n=ScatterDiag_n+temp_data;
end

for k=1:22
        
        ScatterDiag_n(((max_Hs_n*2)+1),k)=sum(ScatterDiag_n(:,k)); 
                                                    %Sum of Hs|Tp
                                                    %CHANGE "35" if Tp
                                                    %interval changes!
    
end
    
for k=1:max_Hs_n*2
        
        ScatterDiag_n(k,24)=sum(ScatterDiag_n(k,:));    %Sum of Hs|Hs
                                                    %CHANGE "24" if Hs
                                                    %interval changes!                                                   
end

%%


%%
%Cumulative distribution of Hs
P_n=zeros(0);     %Probability matrix
[a b]=size(ScatterDiag_n);
[s]=find((ScatterDiag_n(1:a,24))~=0);%Pos of nonzero values 
                                                     %in "Sum of Hs"-column
%for i=1:(max_Hs*2)   
non_zero_SUMS=ScatterDiag_n(s,24);            %Non zero values of SUM-COLUMN
for i=1:length(s)    
    %P(i)=sum(ScatterDiag(1:i,24))/(n+1);   %Sum of Hs/n+1 (last column!)
    P_n(i)=sum(non_zero_SUMS(1:i))/(n+1);     %Cumulative distribution values
                                            %exluding zero valued Hs'
end



%Calculating average Hs within each Hs interval, and average Tp within each
%Hs interval

[ mean_Hs, mean_lnTpgHs,std_lnTpgHs ] = mean_Hs_Tp( max_Hs_n,Hs_n,Tp_n );
avg_Hs_n=mean_Hs(s);           %Excluding nonzero Hs values




%%
%Reading Environmental Data 
[Year,mm,dd,hh,~,~,Hs_all_s,Tp_all_s,Mdir_all_s]=textread('Dogger_south.dat',...
'%f %f %f %f %f %f %f %f %f','headerlines',3);


%%
%Storing data from specific direction in matrices

    %---------
%INPUT


count=0;
Hs_s=zeros(0);
Tp_s=zeros(0);
Mdir_s=zeros(0);

for i=1:length(Year)
%if Mdir(i)==0 || Mdir(i)==360
    if Mdir_all_s(i)<=dir_high && Mdir_all_s(i)>=0 || Mdir_all_s(i)<=360 && ...
                                                    Mdir_all_s(i)>=dir_low
%Creating matrices of Hs, Tp and Dir from within the direction interval
%(north)
        count=count+1;
        Hs_s(count,1)=Hs_all_s(i);
        Tp_s(count,1)=Tp_all_s(i);
        Mdir_s(count,1)=Mdir_all_s(i);
    end
end
%%
%CREATING SCATTER DIAGRAM
max_Hs_s=ceil(max(Hs_s)*2)/2;   %If Hs interval is 0.5 - (number of columns-1)
%max_Hs=ceil(max(Hs)*4)/4;  %If Hs interval is 0.25

ScatterDiag_s=zeros(max_Hs_s*2+1,23); %23: Legger inn enda en kolonne senere (linje 64)

n=length(Mdir_s);

for j=1:n    
    Hs_dummy=Hs_s(j);  Tp_dummy=Tp_s(j);    
    
    [temp_data]=place_HsTp(Hs_dummy,Tp_dummy,max_Hs_s);  
                                                %Placing the number "1"
                                                %in the correct cell in SD
    ScatterDiag_s=ScatterDiag_s+temp_data;
end

for k=1:22
        
        ScatterDiag_s(((max_Hs_s*2)+1),k)=sum(ScatterDiag_s(:,k)); 
                                                    %Sum of Hs|Tp
                                                    %CHANGE "35" if Tp
                                                    %interval changes!
    
end
    
for k=1:max_Hs_s*2
        
        ScatterDiag_s(k,24)=sum(ScatterDiag_s(k,:));    %Sum of Hs|Hs
                                                    %CHANGE "24" if Hs
                                                    %interval changes!                                                   
end

%%


%%
%Cumulative distribution of Hs
P_s=zeros(0);     %Probability matrix
[a b]=size(ScatterDiag_s);
[s]=find((ScatterDiag_s(1:a,24))~=0);%Pos of nonzero values 
                                                     %in "Sum of Hs"-column
%for i=1:(max_Hs*2)   
non_zero_SUMS=ScatterDiag_s(s,24);            %Non zero values of SUM-COLUMN
for i=1:length(s)    
    %P(i)=sum(ScatterDiag(1:i,24))/(n+1);   %Sum of Hs/n+1 (last column!)
    P_s(i)=sum(non_zero_SUMS(1:i))/(n+1);     %Cumulative distribution values
                                            %exluding zero valued Hs'
end



%Calculating average Hs within each Hs interval, and average Tp within each
%Hs interval

[ mean_Hs, mean_lnTpgHs,std_lnTpgHs ] = mean_Hs_Tp( max_Hs_s,Hs_s,Tp_s );
avg_Hs_s=mean_Hs(s);           %Excluding nonzero Hs values

figure(1)
plot(avg_Hs_n,-log(1-P_n),'Marker','.','color','b','displayname','Cumulative distribution northern point')
hold on
plot(avg_Hs_s,-log(1-P_s),'Marker','.','color','r','displayname','Cumulative distribution southern point')
hold off
grid on
xlabel('H_{m0} [m]')
ylabel('-ln(1-F_{H_{m0}})')
legend('location','NorthWest')
 title('Cumulative probability of H_{m0} at northern and southern point')

figure(2)
a=qqplot(Hs_n,Hs_s);
hold on
x=0:0.1:max(Hs_n);
plot(x,x,'k','DisplayName','H_{m0,s}=H_{m0,n}');
hold off
grid on
xlabel('H_{m0,north} [m]')
ylabel('H_{m0,south} [m]')
title('Quantile-Quantile plot')

% Y=sort(Hs_s,'descend');
%  X=sort(Hs_n,'descend');
 
%  figure(3)
%  plot(X(1:length(Y)),Y,'+')
%  max(X(1:length(Y)));
%  hold on
% 
%  x=0:0.1:max(X(1:length(Y)));
%  plot(x,x,'r')
%  grid on