clc
clear all

hs=load('hs_distr_real.mat');
bot=load('botlev.mat');

Hs_short=load('hs_distr.mat');
Hs_long=load('hs_distr2.mat');

Hs_short_qon=load('hs_distr_qon.mat');
Hs_short_qon_wind=load('hs_distr_qon_wind.mat');


[long,lat,d]=textread('Dogger_500m_grid.txt',...
'%f %f %f','headerlines',1);

d=d;

tempVec=[];
for i=0:416:(length(d)-416)
    tempVec=[tempVec d(i+1:i+416)];
    
    
end


Hsig=hs.Hsig;

Botlev=bot.Botlev;




Hsig=double(Hsig);
Botlev=double(Botlev);

x=374560:500:374560+186000;
y=5992690+207500:-500:5992690;
y2=5992690:500:5992690+207500;

[X Y]=meshgrid(x,y);
%[X2 Y2]=meshgrid(x,y2);

figure(2)
surf(X,Y,Hsig)
%axis off
l = light('Position',[-50 -15 29]);
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside
 title('Significant wave height over the computational domain - Short crested sea state')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')
pbaspect([1 1 1])
%view(126,12)

figure(3)
surf(X,Y,-Botlev)
%axis off
l = light('Position',[-50 -15 29]);
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside
 title('Significant wave height over the computational domain - Short crested sea state')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')
pbaspect([186000 207500 186000])
%view(126,12)

figure(4)
surf(X,Y,-tempVec)
%axis off
l = light('Position',[-50 -15 29]);
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside
 title('Significant wave height over the computational domain - Short crested sea state')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')
pbaspect([186000 207500 186000])
%view(126,12)

fid=fopen('bottom.txt','w');

for i=1:length(tempVec)

    str=num2str(tempVec(i,:));
    
fprintf(fid,'%s\n',str);

end



fclose(fid)

Hs_long=double(Hs_long.Hsig);
Hs_short=double(Hs_short.Hsig);

Hs_short_qon=double(Hs_short_qon.Hsig);
Hs_short_qon_wind=double(Hs_short_qon_wind.Hsig);


xx=0:1377.187/69:1377.187;
yy=0:5000/251:5000;

[XX YY]=meshgrid(xx,yy);



figure(5)
surf(XX,YY,Hs_long)
%axis off
l = light('Position',[-50 -15 29]);
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside
 title('Significant wave height over the computational domain - Short crested sea state')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')
pbaspect([1 1 1])
view(126,12)

figure(6)
surf(XX,YY,Hs_short)
%axis off
l = light('Position',[-50 -15 29]);
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside
 title('Significant wave height over the computational domain - Short crested, Q=off, no wind')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')
pbaspect([1 1 1])
view(126,12)

figure(7)
surf(XX,YY,Hs_short_qon)
%axis off
l = light('Position',[-50 -15 29]);
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside
 title('Significant wave height over the computational domain - Short crested, Q=on, no wind')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')
pbaspect([1 1 1])
view(126,12)

figure(8)
surf(XX,YY,Hs_short_qon_wind)
%axis off
l = light('Position',[-50 -15 29]);
set(gca,'CameraPosition',[208 -50 7687])
lighting phong
shading interp
colorbar EastOutside
 title('Significant wave height over the computational domain - Short crested, Q=on, Wind=25 m/s')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')
pbaspect([1 1 1])
view(126,12)

% Hs_1=load('hs_distr11.mat');
% Hs_2=load('hs_distr22.mat');
% Hs_3=load('hs_distr33.mat');
% 
% Hs_1=double(Hs_1.Hsig);
% Hs_2=double(Hs_2.Hsig);
% Hs_3=double(Hs_3.Hsig);
% 
% xxx=0:1377.187/69:1377.187;
% 
% yyy2=0:20000/1004:20000;
% yyy3=0:40000/2008:40000;
% 
% [XXX YYY1]=meshgrid(xxx,yyy2);
% 
% [XXX1 YYY2]=meshgrid(xxx,yyy3);
% 
% 
% figure(9)
% surf(XX,YY,Hs_1)
% %axis off
% l = light('Position',[-50 -15 29]);
% set(gca,'CameraPosition',[208 -50 7687])
% lighting phong
% shading interp
% colorbar EastOutside
%  title('Significant wave height over the computational domain - Short crested, bredde 5000')
% ylabel('y-axis [m]')
% xlabel('x-axis [m]')
% zlabel('H_{m0} [m]')
% pbaspect([1 1 1])
% view(126,12)
% 
% figure(10)
% surf(XX,YY,Hs_2)
% %axis off
% l = light('Position',[-50 -15 29]);
% set(gca,'CameraPosition',[208 -50 7687])
% lighting phong
% shading interp
% colorbar EastOutside
%  title('Significant wave height over the computational domain - Short crested, Q=on, bredde 20000')
% ylabel('y-axis [m]')
% xlabel('x-axis [m]')
% zlabel('H_{m0} [m]')
% pbaspect([1 1 1])
% view(126,12)
% 
% 
% figure(11)
% surf(XX,YY,Hs_3)
% %axis off
% l = light('Position',[-50 -15 29]);
% set(gca,'CameraPosition',[208 -50 7687])
% lighting phong
% shading interp
% colorbar EastOutside
%  title('Significant wave height over the computational domain - Short crested, Q=on, bredde 40000')
% ylabel('y-axis [m]')
% xlabel('x-axis [m]')
% zlabel('H_{m0} [m]')
% pbaspect([1 1 1])
% view(126,12)

