Hs_1=load('SWAN/Hs_distr/real/hs_all1.mat');
Hs_2=load('SWAN/Hs_distr/real/hs_all2.mat');
Hs_3=load('SWAN/Hs_distr/real/hs_all3.mat');
Hs_4=load('SWAN/Hs_distr/real/hs_all4.mat');
Hs_5=load('SWAN/Hs_distr/real/hs_all5.mat');
Hs_6=load('SWAN/Hs_distr/real/hs_all6.mat');



Hs_1=double(Hs_1.Hsig);
Hs_2=double(Hs_2.Hsig);
Hs_3=double(Hs_3.Hsig);
Hs_4=double(Hs_4.Hsig);
Hs_5=double(Hs_5.Hsig);
Hs_6=double(Hs_6.Hsig);



x1=374560:186000/2188:(374560+186000);
y1=(6050190+134000):-134000/1576:6050190;

x2=374560:186000/1860:(374560+186000);
y2=(6050190+134000):-134000/1340:6050190;

x3=374560:186000/930:(374560+186000);
y3=(6050190+134000):-134000/670:6050190;

x4=374560:186000/372:(374560+186000);
y4=(6050190+134000):-134000/268:6050190;

x5=374560:186000/248:(374560+186000);
y5=(6050190+134000):-134000/178:6050190;

x6=374560:186000/186:(374560+186000);
y6=(6050190+134000):-134000/134:6050190;


[X1 Y1]=meshgrid(x1,y1);
[X2 Y2]=meshgrid(x2,y2);
[X3 Y3]=meshgrid(x3,y3);
[X4 Y4]=meshgrid(x4,y4);
[X5 Y5]=meshgrid(x5,y5);
[X6 Y6]=meshgrid(x6,y6);


figure(1)
surf(X1,Y1,Hs_1)
view(0,90)
lighting phong
shading interp
colorbar EastOutside
 title('Hs')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')

figure(2)
surf(X2,Y2,Hs_2)
view(0,90)
lighting phong
shading interp
colorbar EastOutside
 title('Hs')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')

figure(3)
surf(X3,Y3,Hs_3)
view(0,90)
lighting phong
shading interp
colorbar EastOutside
 title('Hs')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')

figure(4)
surf(X4,Y4,Hs_4)
view(0,90)
lighting phong
shading interp
colorbar EastOutside
 title('Hs')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')

figure(5)
surf(X5,Y5,Hs_5)
view(0,90)
lighting phong
shading interp
colorbar EastOutside
 title('Hs')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')

figure(6)
surf(X6,Y6,Hs_6)
view(0,90)
lighting phong
shading interp
colorbar EastOutside
 title('Hs')
ylabel('y-axis [m]')
xlabel('x-axis [m]')
zlabel('H_{m0} [m]')

%-------------------------------------------------------------------------%
%-------------------------------------------------------------------------%
%-------------------------------------------------------------------------%
%-------------------------------------------------------------------------%
%-------------------------------------------------------------------------%
%-------------------------------------------------------------------------%
%-------------------------------------------------------------------------%
%-------------------------------------------------------------------------%
%-------------------------------------------------------------------------%


for runs=1:6
clearvars -except Hs_evolve spec_start spec_end Hs_start_full Hs_end_full Hs_start_model Hs_end_model runs
    
str3=['Runs\',num2str(runs),'\Hs_evolve.tab'];

[~,~,d,Hs_evol]=textread(str3,...
'%f %f %f %f ','headerlines',7);

Hs_evolve(:,runs)=Hs_evol;

[ Hs1,Hs2,Hs1_mod,Hs2_mod,f1,spec1,f2,spec2 ] = spec_from_file( runs );

spec_start(:,runs)=spec1;
spec_end(:,runs)=spec2;




Hs_start_full(runs)=Hs1;
Hs_end_full(runs)=Hs2;
Hs_start_model(runs)=Hs1_mod;
Hs_end_model(runs)=Hs2_mod;




Hs_start_full(runs)=Hs1;
Hs_end_full(runs)=Hs2;
Hs_start_model(runs)=Hs1_mod;
Hs_end_model(runs)=Hs2_mod;


end

Tp=11.25; %NOE RART MED DENNE, FINNER DEN IKKE I OUTPUT FRA SWAN!
x_axis2=zeros(0);
for i=1:length(d)
    
    lambda=9.81/(2*pi)*Tp^2;
    
    n=0;
    while abs(lambda-(9.81/(2*pi))*Tp^2*tanh(2*pi*d(i)/lambda))>0.000001;


        lambda=(9.81/(2*pi))*Tp^2*tanh(2*pi*d(i)/lambda);

    end
  
    x_axis2(i)=d(i)/lambda;
end

figure(7)
plot(x_axis2,Hs_evolve)
test=legend('dx=dy=85m','dx=dy=100m','dx=dy=200m','dx=dy=500m','dx=dy=750m','dx=dy=1000m')
set(test,'Location','best')
xlabel('Hz')
ylabel('m^{2}s')


