clc
clearvars -except x_axis
%RUN SVANG FIRST


%1= QUADS ON
%2=QUADS OFF
for runs=1:2
    
  [ f1,spec1 ] = spec_from_file_evolve( runs );

    
   if runs==1
       F1=f1';
       Spec1=spec1;
       
   elseif runs==2
       F2=f1';
       Spec2=spec1;
       
   end
    
end


figure(80)
hold on

% subplot(3,3,1)
hold on
plot(F1,Spec1(:,1),'g','Displayname','Input: JONSWAP')
xlim([0.0 0.35])
xlabel('[Hz]')
ylabel('m^{2}s')
title('Wave spectrum at WP02 (d=67.23 m)')

figure(81)
% subplot(3,3,2)
hold on
plot(F1,Spec1(:,2),'g','Displayname','Calculated (Jonswap input spectrum)')
xlim([0.0 0.35])
xlabel('[Hz]')
ylabel('m^{2}s')
title('Wave spectrum at WP03 (d=54.35 m)')

figure(82)
% subplot(3,3,3)
hold on
plot(F1,Spec1(:,3),'g','Displayname','Calculated (Jonswap input spectrum)')
xlim([0.0 0.35])
xlabel('[Hz]')
ylabel('m^{2}s')
title('Wave spectrum at WP04 (d=40 m)')

figure(83)
% subplot(3,3,4)
hold on
plot(F1,Spec1(:,4),'g','Displayname','Calculated (Jonswap input spectrum)')
xlim([0.0 0.35])
xlabel('[Hz]')
ylabel('m^{2}s')
title('Wave spectrum at WP05 (d=30 m)')

figure(84)
% subplot(3,3,5)
hold on
plot(F1,Spec1(:,8),'g','Displayname','Calculated (Jonswap input spectrum)')
xlim([0.0 0.35])
xlabel('[Hz]')
ylabel('m^{2}s')
title('Wave spectrum at WP11 (d=25 m)')

figure(85)
% subplot(3,3,6)
hold on
plot(F1,Spec1(:,12),'g','Displayname','Calculated (Jonswap input spectrum)')
xlim([0.0 0.35])
xlabel('[Hz]')
ylabel('m^{2}s')
title('Wave spectrum at WP06 (d=20 m)')

figure(86)
% subplot(3,3,7)
hold on
plot(F1,Spec1(:,13),'g','Displayname','Calculated (Jonswap input spectrum)')
xlim([0.0 0.35])
xlabel('[Hz]')
ylabel('m^{2}s')
title('Wave spectrum at WP07 (d=15 m)')


figure(80)
hold on

% subplot(3,3,1)
hold on
plot(F1,Spec2(:,1),'r','Displayname','Input: MEASURED')
legend('show')


figure(81)
% subplot(3,3,2)
hold on
plot(F1,Spec2(:,2),'r','Displayname','Calculated (Measured input spectrum)')
legend('show')


figure(82)
% subplot(3,3,3)
hold on
plot(F1,Spec2(:,3),'r','Displayname','Calculated (Measured input spectrum)')
legend('show')

figure(83)
% subplot(3,3,4)
hold on
plot(F1,Spec2(:,4),'r','Displayname','Calculated (Measured input spectrum)')
legend('show')


figure(84)
% subplot(3,3,5)
hold on
plot(F1,Spec2(:,8),'r','Displayname','Calculated (Measured input spectrum)')
legend('show')


figure(85)
% subplot(3,3,6)
hold on
plot(F1,Spec2(:,12),'r','Displayname','Calculated (Measured input spectrum)')
legend('show')

figure(86)
% subplot(3,3,7)
hold on
plot(F1,Spec2(:,13),'r','Displayname','Calculated (Measured input spectrum)')
legend('show')


figure(2)
plot(F1,Spec1)



figure(5)
hold on

subplot(3,3,1)
hold on
plot(F1,Spec1(:,1)-Spec2(:,1),'Displayname','Input spectrum {S(f)}_{Q=on}-{S(f)}_{Q=off}')
legend('show')
xlim([0.05 0.5])
xlabel('[Hz]')
ylabel('m^{2}s')
title('Spectrum difference at WP02 (d=67.23 m)')
plot([0 1],[0 0],'--k')
%%


%%
hold off

subplot(3,3,2)
hold on
plot(F1,Spec1(:,2)-Spec2(:,2),'Displayname','{S(f)}_{Q=on}-{S(f)}_{Q=off}')
legend('show')
xlim([0.05 0.5])
xlabel('[Hz]')
ylabel('m^{2}s')
title('Spectrum difference at WP02 (d=54.35 m)')
plot([0 1],[0 0],'--k')

hold off

subplot(3,3,3)
hold on
plot(F1,Spec1(:,3)-Spec2(:,3),'Displayname','{S(f)}_{Q=on}-{S(f)}_{Q=off}')
legend('show')
xlim([0.05 0.5])
xlabel('[Hz]')
ylabel('m^{2}s')
title('Spectrum difference at WP04 (d=40 m)')
plot([0 1],[0 0],'--k')

hold off

subplot(3,3,4)
hold on
plot(F1,Spec1(:,4)-Spec2(:,4),'Displayname','{S(f)}_{Q=on}-{S(f)}_{Q=off}')
xlim([0.05 0.5])
xlabel('[Hz]')
ylabel('m^{2}s')
title('Spectrum difference at WP05 (d=30 m)')

legend('show')
plot([0 1],[0 0],'--k')
hold off


subplot(3,3,5)
hold on
plot(F1,Spec1(:,8)-Spec2(:,8),'Displayname','{S(f)}_{Q=on}-{S(f)}_{Q=off}')
xlim([0.05 0.5])
xlabel('[Hz]')
ylabel('m^{2}s')
title('Spectrum difference at WP11 (d=25 m)')

legend('show')
plot([0 1],[0 0],'--k')
hold off


subplot(3,3,6)
hold on
plot(F1,Spec1(:,12)-Spec2(:,12),'Displayname','{S(f)}_{Q=on}-{S(f)}_{Q=off}')
xlim([0.05 0.5])
xlabel('[Hz]')
ylabel('m^{2}s')
title('Spectrum difference at WP06 (d=20 m)')

legend('show')
plot([0 1],[0 0],'--k')
hold off

subplot(3,3,7)
hold on
plot(F1,Spec1(:,13)-Spec2(:,13),'Displayname','{S(f)}_{Q=on}-{S(f)}_{Q=off}')

legend('show')
plot([0 1],[0 0],'--k')
hold off

xlim([0.05 0.5])
xlabel('[Hz]')
ylabel('m^{2}s')
title('Spectrum difference at WP07 (d=15 m)')
hold off


