clc
clear all

fid = fopen('spectr_start.tab', 'r');
f1=zeros(0);
spec1=zeros(0);
while 1
tline = fgetl(fid);         %goes through log-file, line by line
if strfind(tline, 'AFREQ')   %searches for the string "AFREQ"
    tline = fgetl(fid);
	n_freq=str2num(tline(1:20));
    for i=1:n_freq
         tline = fgetl(fid);
         f1(i)=str2num(tline(1:10));
    end

end

if strfind(tline, 'LOCATION     1')   %searches for the string "AFREQ"
    for j=1:n_freq
         tline = fgetl(fid);
         spec1(j)=str2num(tline(1:12));
    end

end

if ~ischar(tline), break, end 
end
fclose(fid)
% 
% figure(1)
% spetrum=plot(f,spec);
% xlim([0 0.35])
% [a b]=max(spec);
% Tp=1/(f(b))
% Hs=4*sqrt(trapz(f,spec))
% %hold on
%

fid = fopen('spectr_end.tab', 'r');
f2=zeros(0);
spec2=zeros(0);
while 1
tline = fgetl(fid);         %goes through log-file, line by line
if strfind(tline, 'AFREQ')   %searches for the string "AFREQ"
    tline = fgetl(fid);
	n_freq=str2num(tline(1:20));
    for i=1:n_freq
         tline = fgetl(fid);
         f2(i)=str2num(tline(1:10));
    end

end

if strfind(tline, 'LOCATION     1')   %searches for the string "AFREQ"
    for j=1:n_freq
         tline = fgetl(fid);
         spec2(j)=str2num(tline(1:12));
    end

end

if ~ischar(tline), break, end 
end
fclose(fid)

[a b]=max(spec1);
Tp1=1/(f1(b))
Hs1=4*sqrt(trapz(f1,spec1))

[a b]=max(spec2);
Tp1=1/(f2(b))
Hs2=4*sqrt(trapz(f2,spec2))

figure(1)
spetrum=plot(f1,spec1,f2,spec2);
xlim([0 0.35])
xlabel('Hz');
box('on');
ylabel('m^2*s');
title('Transformation of spectrum - FULL SCALE');
legend('show');
set(spetrum(1),'DisplayName',['Input spectrum (JONSWAP) Hs=',num2str(Hs1), ', Tp=11.25']);
set(spetrum(2),'Color',[1 0 0],...
    'DisplayName',['Ouput spectrum at 15m water depth, Hs=',num2str(Hs2),' Tp=11.25']);

figure(2)
hz_scale=(2*pi*sqrt(81));
spec_scale=1/((81^2)*sqrt(81)*2*pi);
spetrum=plot(f1.*hz_scale,spec1.*spec_scale,f2.*hz_scale,spec2.*spec_scale);
xlim([0 30])
xlabel('rad/s');
box('on');
ylabel('m^2*s');
title('Transformation of spectrum - MODEL SCALE');
legend('show');

Hs1_mod=4*sqrt(trapz(f1.*hz_scale,spec1.*spec_scale));
Hs2_mod=4*sqrt(trapz(f2.*hz_scale,spec2.*spec_scale));

set(spetrum(1),'DisplayName',['Input spectrum (JONSWAP) Hs=',num2str(Hs1_mod), ', Tp=11.25']);
set(spetrum(2),'Color',[1 0 0],...
    'DisplayName',['Ouput spectrum at 15m water depth, Hs=',num2str(Hs2_mod),' Tp=11.25']);




