clc
clear all

%INPUT!!!!
depth=20.69;
cylinder_length=32;
n_sea_states=1;
cylinder_D=6;
rho=1025;


%KINEMATICS

str1=['WAJAC_kinematics.LIS']; 


fid1 = fopen(str1, 'r');
fid2 = fopen('WAJAC_kin_replaced.LIS', 'w');

while 1
tline = fgetl(fid1); %goes through log-file, line by line
temp_string=strrep(tline,' SURFACE ',num2str(-999));
fprintf(fid2,'%s\n',temp_string);



if ~ischar(tline), break, end 
end
fclose(fid1);
fclose(fid2);




fid3 = fopen('WAJAC_kin_replaced.LIS', 'r');


l_number=zeros(0);

line_number=0;
while 1
tline = fgetl(fid3); %goes through log-file, line by line
line_number=line_number+1;
if strfind(tline, ' W A V E  /  W I N D    K I N E M A T I C S')   %searches for the string
  
  l_number=line_number;
    
elseif strfind(tline, 'SUMMARY OF MAXIMUM BASE SHEAR AND OVERTURNING MOMENT:')   
   l_number2=line_number;

end


if ~ischar(tline), break, end 
end
fclose(fid3);


newData1 = importdata('WAJAC_kin_replaced.LIS', ' ', l_number+16);

sea_state1_1=newData1.data(1:length(newData1.data)-1,:);

n_points=length(sea_state1_1);




count=0;
tempdata=0;
for i=(l_number+16):(n_points+9):(l_number+16)+(2*n_sea_states-1)*(n_points+9);
    count=count+1;
    
   
   tempdata=importdata('WAJAC_kin_replaced.LIS', ' ', i);
   tempdata2=tempdata.data(1:length(tempdata.data),:);
   
   if length(find(isnan(tempdata2)==1))~=0
        tempdata2=tempdata2(1:length(tempdata2)-1,:);
   end
   
   velocity_matrix(:,count)=tempdata2(:,6);
   acc_matrix(:,count)=tempdata2(:,9);
   
   y_axis(:,count)=tempdata2(:,4);
   
   tempdata=0;
   tempdata2=0;
end

%%
[I J]=find(y_axis==-999);   %rows and columns where -999 occurs
II=diff(I);                    
III=find(II<0);             %position of last -999 in each column

pos_i=I(III);
pos_i(length(pos_i)+1)=I(length(I));

pos_j=J(III);
pos_j(length(pos_j)+1)=J(length(J)); %Position of first value in y_xis and vel/acc vector

pos_i=pos_i+1;              %Position of first value in y_xis and vel/acc vector






 figure(2)
 hold on
 plot(velocity_matrix(pos_i(1):length(velocity_matrix),1),y_axis(pos_i(1):length(y_axis),1),'b','displayname','Airy w/ wheeler at max BS');
 plot(velocity_matrix(pos_i(2):length(velocity_matrix),2),y_axis(pos_i(2):length(y_axis),2),'--b','displayname','Airy w/ wheeler at max OM');
% plot(velocity_matrix(pos_i(3):length(velocity_matrix),3),y_axis(pos_i(3):length(y_axis),3),'r','displayname','Airy  at max BS');
% plot(velocity_matrix(pos_i(4):length(velocity_matrix),4),y_axis(pos_i(4):length(y_axis),4),'--r','displayname','Airy at max OM')
% plot(velocity_matrix(pos_i(5):length(velocity_matrix),5),y_axis(pos_i(5):length(y_axis),5),'g','displayname','Stokes 5th at max BS')
% plot(velocity_matrix(pos_i(6):length(velocity_matrix),6),y_axis(pos_i(6):length(y_axis),6),'--g','displayname','Stokes 5th at max OM')
% plot(velocity_matrix(pos_i(7):length(velocity_matrix),7),y_axis(pos_i(7):length(y_axis),7),'k','displayname','Stream 10th at max BS')
% plot(velocity_matrix(pos_i(8):length(velocity_matrix),8),y_axis(pos_i(8):length(y_axis),8),'--k','displayname','Stream 10th at max OM')
% 
 legend('show')
% 
 hold off
% 
% 
 xlabel('Horisontal fluid velocity at center of cylinder [m/s]')
 ylabel('y [m]')
% 
 title('Horizontal fluid velocity')
% 
% 
 figure(3)
 hold on
% 
 plot(acc_matrix(pos_i(1):length(acc_matrix),1),y_axis(pos_i(1):length(y_axis),1),'b','displayname','Airy w/ wheeler at max BS');
 plot(acc_matrix(pos_i(2):length(acc_matrix),2),y_axis(pos_i(2):length(y_axis),2),'--b','displayname','Airy w/ wheeler at max OM');
% plot(acc_matrix(pos_i(3):length(acc_matrix),3),y_axis(pos_i(3):length(y_axis),3),'r','displayname','Airy  at max BS');
% plot(acc_matrix(pos_i(4):length(acc_matrix),4),y_axis(pos_i(4):length(y_axis),4),'--r','displayname','Airy at max OM')
% plot(acc_matrix(pos_i(5):length(acc_matrix),5),y_axis(pos_i(5):length(y_axis),5),'g','displayname','Stokes 5th at max BS')
% plot(acc_matrix(pos_i(6):length(acc_matrix),6),y_axis(pos_i(6):length(y_axis),6),'--g','displayname','Stokes 5th at max OM')
% plot(acc_matrix(pos_i(7):length(acc_matrix),7),y_axis(pos_i(7):length(y_axis),7),'k','displayname','Stream 10th at max BS')
% plot(acc_matrix(pos_i(8):length(acc_matrix),8),y_axis(pos_i(8):length(y_axis),8),'--k','displayname','Stream 10th at max OM')
% legend('show')
% 
 hold off
% 
% 
 xlabel('Horisontal fluid acceleration at center of cylinder [m/s^{2}]')
 ylabel('y [m]')
% 
 title('Horizontal fluid acceleration')


max_data=importdata('WAJAC_kinematics.LIS', ' ', l_number2+5);
max_data=max_data.data;



%WAVE PROFILEs



fid4 = fopen('WAJAC_elev.LIS', 'r');


l_number_elev=zeros(0);

line_number_elev=0;
while 1
tline = fgetl(fid4); %goes through log-file, line by line
line_number_elev=line_number_elev+1;
if strfind(tline, ' W A V E  /  W I N D    K I N E M A T I C S')   %searches for the string
  
  l_number_elev=line_number_elev;
    

end


if ~ischar(tline), break, end 
end
fclose(fid4);


newData2 = importdata('WAJAC_elev.LIS', ' ', l_number_elev+16);

sea_state1_1_elev=newData2.data(1:length(newData2.data)-1,:);

n_points_elev=length(sea_state1_1_elev);



count=0;
tempdata=0;
for i=(l_number_elev+16):(n_points_elev+9):(l_number_elev+16)+(2*n_sea_states-1)*(n_points_elev+9);
    count=count+1;
    
   
   tempdata=importdata('WAJAC_elev.LIS', ' ', i);
   tempdata2=tempdata.data(1:length(tempdata.data),:);
   
   if length(find(isnan(tempdata2)==1))~=0
        tempdata2=tempdata2(1:length(tempdata2)-1,:);
   end
   
   elevation_matrix(:,count)=tempdata2(:,5);
   
   x_axis=tempdata2(:,2);
   
   tempdata=0;
   tempdata2=0;
end



figure(1)
plot1=plot(x_axis,elevation_matrix);
% set(plot1(1),'Color','b','displayname','Airy w/ Wheeler - Max Base Shear');
% set(plot1(2),'LineStyle','--','Color','b','displayname','Airy w/ Wheeler - Max Overturning Moment');
% set(plot1(3),'Color','r','displayname','Airy - Max Base Shear');
% set(plot1(4),'LineStyle','--','Color','r','displayname','Airy - Max Overturning Moment');
% set(plot1(5),'Color','g','displayname','Stokes 5th - Max Base Shear');
% set(plot1(6),'LineStyle','--','Color','g','displayname','Stokes 5th - Max Overturning Moment');
set(plot1(1),'Color','k','displayname','Stream Function 10th - Max Base Shear');
set(plot1(2),'LineStyle','--','Color','k','displayname','Stream Function 10th - Max Overturning Moment');
hold on
line([cylinder_D/2 cylinder_D/2], [0 cylinder_length],'color','c','displayname','Cylinder')
plot([min(x_axis) max(x_axis)],[depth depth],'--m','Displayname','Mean Water Level')

legend('show')

line([-cylinder_D/2 -cylinder_D/2], [0 cylinder_length],'color','c')
line([cylinder_D/2 -cylinder_D/2], [cylinder_length cylinder_length],'color','c')


pbaspect([abs(min(x_axis)-max(x_axis)) cylinder_length 1])
xlabel('x [m]')
ylabel('y [m]')

title('Wave profiles at maximum base shear and overturning moment. Propagation in posisitve x')


hold off




%%

% %CALCULATE FORCES
% force=[];
% count=0;
% for i=1:2:8
% count=count+1;
% temp_vel=velocity_matrix(pos_i(i):length(velocity_matrix),i);
% temp_acc=acc_matrix(pos_i(i):length(acc_matrix),i);
% temp_y=y_axis(pos_i(i):length(y_axis),i);
% 
% 
% 
% temp_vel(length(temp_vel)+1)=0;
% temp_acc(length(temp_acc)+1)=0;
% temp_y(length(temp_y)+1)=0;
% 
% % diff_y=-diff(temp_y);
% % diff_vel=-diff(temp_vel);
% % diff_acc=-diff(temp_acc);
% 
% force_1=rho*pi*2*((cylinder_D^2)/4)*trapz(temp_y,temp_acc);
% force_2=0.5*rho*1*cylinder_D*trapz(temp_y,temp_vel.^2);
% 
% force(count,1)=force_1+force_2;
% 
% end
% 
% 
% 
% moment=[];
% count=0;
% for i=2:2:8
% count=count+1;
% temp_vel=velocity_matrix(pos_i(i):length(velocity_matrix),i);
% temp_acc=acc_matrix(pos_i(i):length(acc_matrix),i);
% temp_y=y_axis(pos_i(i):length(y_axis),i);
% 
% 
% 
% temp_vel(length(temp_vel)+1)=0;
% temp_acc(length(temp_acc)+1)=0;
% temp_y(length(temp_y)+1)=0;
% 
% % diff_y=-diff(temp_y);
% % diff_vel=-diff(temp_vel);
% % diff_acc=-diff(temp_acc);
% 
% 
% temp_force_1=rho*pi*2*((cylinder_D^2)/4)*trapz(temp_y,temp_acc);
% temp_force_2=0.5*rho*1*cylinder_D*trapz(temp_y,temp_vel.^2);
% 
% 
% 
% 
% 
% end
% 







